FishPounds={}

local function IsWaterTile(x,z)
    return GLOBAL.TheWorld.Map:CanDeployAtPointInWater({x=x,y=0,z=z}, nil, nil, {radius=1})
end

GLOBAL.ACTIONS.FISH.fn=function(act)
    local fishingrod = act.invobject.components.fishingrod
    local x,y,z=act.target.Transform:GetWorldPosition()
    if fishingrod and (not act.target:HasTag("NOCLICK") or IsWaterTile(x,z)) then
        fishingrod:StartFishing(act.target, act.doer)
        return true
    end
    act.doer.sg:GoToState("idle")
    return false
end

AddModRPCHandler(modname,"INITFISHING",function(player)
    if not GLOBAL.TheWorld.has_ocean then
        return
    end
    local inst=GLOBAL.SpawnPrefab("pond_cave")
    inst:DoTaskInTime(0.1,function()
        for i,v in ipairs(inst.plant_ents or {}) do
            v:Remove()
        end
        inst.plant_ents={}
    end)
    inst.AnimState:SetScale(0,0,0)
    inst.Transform:SetScale(0.5,0.5,0.5)
    inst.MiniMapEntity:SetEnabled(false)
    inst.Physics:SetActive(false)
    inst.prefab=""
    inst:AddTag("NOBLOCK")
    inst:RemoveTag("antlion_sinkhole_blocker")
    inst:RemoveTag("birdblocker")
    inst.components.fishable.fish = {fish="fish"}
    inst:RemoveComponent("inspectable")
    FishPounds[player.userid]=inst
end)

AddModRPCHandler(modname,"UPDATEFISHING",function(player,x,z)
    if FishPounds[player.userid]~=nil and FishPounds[player.userid]:IsValid() then
        local inst=FishPounds[player.userid]
        if IsWaterTile(x,z) then
            inst.components.fishable:Unfreeze()
            inst:RemoveTag("NOCLICK")
        else
            inst.components.fishable:Freeze()
            inst:AddTag("NOCLICK")
        end
        inst.Transform:SetPosition(x,0,z)
    end
end)

AddSimPostInit(function()
    if not GLOBAL.TheNet:IsDedicated() then
        TheWorld=GLOBAL.TheWorld
        if not TheWorld.has_ocean then
            return
        end
        local function InitFishing()
            SendModRPCToServer(MOD_RPC[modname]["INITFISHING"])
            TheWorld.fishinited=true
        end
        local function UpdateFishing()
            if not TheWorld.fishinited then
                InitFishing()
            end
            local pos=GLOBAL.TheInput:GetWorldPosition()
            SendModRPCToServer(MOD_RPC[modname]["UPDATEFISHING"],pos.x,pos.z)
        end
        TheWorld:DoPeriodicTask(.2,UpdateFishing)
    end
end)